from lxml import etree 
from lxml.etree import DocumentInvalid
import lxml
import glob

import pprint
pp = pprint.PrettyPrinter(indent=2)

import yaml

class XSDValidator:

    def __init__(self, xsd_path):
        xmlschema_doc = etree.parse(xsd_path)
        self.xmlschema = etree.XMLSchema(xmlschema_doc)

    def validate(self, xml_path):
        xml_doc = etree.parse(xml_path)
        try:
            self.xmlschema.assertValid(xml_doc)
        except lxml.etree.DocumentInvalid:
            print("Validation error(s):")
            for error in self.xmlschema.error_log:
                print("  Line {}: {}".format(error.line, error.message))
        return self.xmlschema.validate(xml_doc)


class XMLList:

    def __init__(self, config):
        self.files = set(glob.glob(config['package_glob']))

    def getfiles(self, testname):
        #if testname in self.skip.keys():
        #    return self.files - set(self.skip[testname])
        #else:
            return self.files

class Config:
    def __init__(self):
        with open('config.yml', 'r') as conffile:
            self.config = yaml.load(conffile)
